/************************************************************
	t@C:display.c
	Tv:\퐧֐
	^[Qbg:PIC16F88(20MHz)
	|[gA:AiO(RA0, RA1)A(RA2, RA3)
	|[gB:LED(RB0?RB7)
	쐬:2012/07/20
************************************************************/

//wb_t@C
#include "common.h"		//\[Xt@Cԋ
#include "display.h"	//vg^Cv錾

/*
	֐:dec2bcd4
	Tv:10i4̐l4̔zɊi[
	*bcd:4̕\f[^i[ꂽz̐擪AhX
	dec:\ΏۂƂȂ10i̐l
	߂l:Ȃ
*/
void dec2bcd4(unsigned char *bcd, unsigned short dec)
{

	bcd[3] = dec % 10000 / 1000;	//3(ŏʌ)
	bcd[2] = dec % 1000 / 100;		//2
	bcd[1] = dec % 100 / 10;		//1
	bcd[0] = dec % 10;				//0(ŉʌ)
}

/*
	֐:dec2hex4
	Tv:16i4̐l4̔zɊi[
	*bcd:4̕\f[^i[ꂽz̐擪AhX
	dec:\ΏۂƂȂ16i̐l
	߂l:Ȃ
*/
void dec2hex4(unsigned char *bcd, unsigned short dec)
{
	unsigned char i = 4;

	while (i--) {
		bcd[i] = 0x0F & (dec >> (i << 2));
	}
}

/*
	֐:dec2temp
	Tv:10i4̐lx\p4̔zɊi[
	*bcd:\f[^i[ꂽz̐擪AhX
	dec:\ΏۂƂȂ10i̐l
	߂l:Ȃ
	lF(2.56)256025.6cƂĊi[
*/
void dec2temp(unsigned char *bcd, unsigned short dec)
{

	bcd[3] = dec % 10000 / 1000;	//3(ŏʌ)
	bcd[2] = dec % 1000 / 100;		//2
	bcd[1] = dec % 100 / 10;		//1
	bcd[0] = 0x0C;					//x\(ŉʌ)
}

/*
	֐:seg_disp4
	Tv:7ZO10i4Ń_Ci~bN_
	*bcd:4̕\f[^i[ꂽz̐擪AhX
	߂l:Ȃ
*/
void seg_disp4(const unsigned char *bcd)
{
	unsigned char i = SEG_DIGIT;

	while (i--) {
		SEG_ON(i, *(bcd + i));	//l\
		__delay_ms(10 / SEG_DIGIT);			//
		SEG_OFF();				//l\Ȃ
	}
}

/*
	֐:seg_disp4
	Tv:7ZO10i4Ń_Ci~bN_hbg|Cg
	*bcd:4̕\f[^i[ꂽz̐擪AhX
	dp:hbg\錅ʒu(d=0:ŏʌ?3:őʌ)
	߂l:Ȃ
*/
void seg_disp4dp(const unsigned char *bcd, unsigned char dp)
{
	unsigned char i = SEG_DIGIT;

	while (i--) {
		if(i == dp) {
			SEG_ON_DP(i, *(bcd + i));	//l\hbg
		}
		else {
			SEG_ON(i, *(bcd + i));	//l\
		}
		__delay_ms(10 / SEG_DIGIT);
		SEG_OFF();				//l\Ȃ
	}
}
